export declare class DecoderError extends Error {
    name: string;
}
export declare class OneOfDecoderError extends DecoderError {
    name: string;
    constructor(errors: Error[]);
}
export declare class AtDecoderError extends DecoderError {
    path: string | number;
    name: string;
    constructor(path: string | number, err: Error);
}
export declare class ArrayDecoderError extends DecoderError {
    index: number;
    name: string;
    constructor(index: number, err: Error);
}
export declare class PropsDecoderError extends DecoderError {
    key: string;
    name: string;
    constructor(key: string, err: Error);
}
export declare class ScalarDecoderError extends DecoderError {
    expectedType: string;
    value: unknown;
    name: string;
    constructor(expectedType: string, value: unknown);
}
export declare class StrictDecoderError extends DecoderError {
    expectedValue: unknown;
    value: unknown;
    name: string;
    constructor(expectedValue: unknown, value: unknown);
}
//# sourceMappingURL=errors.d.ts.map