(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./errors", "./decoders"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var errors_1 = require("./errors");
    exports.ArrayDecoderError = errors_1.ArrayDecoderError;
    exports.AtDecoderError = errors_1.AtDecoderError;
    exports.DecoderError = errors_1.DecoderError;
    exports.OneOfDecoderError = errors_1.OneOfDecoderError;
    exports.PropsDecoderError = errors_1.PropsDecoderError;
    exports.ScalarDecoderError = errors_1.ScalarDecoderError;
    exports.StrictDecoderError = errors_1.StrictDecoderError;
    var decoders_1 = require("./decoders");
    exports.array = decoders_1.array;
    exports.assoc = decoders_1.assoc;
    exports.at = decoders_1.at;
    exports.attempt = decoders_1.attempt;
    exports.boolean = decoders_1.boolean;
    exports.date = decoders_1.date;
    exports.is = decoders_1.is;
    exports.null_ = decoders_1.null_;
    exports.nullable = decoders_1.nullable;
    exports.number = decoders_1.number;
    exports.oneOf = decoders_1.oneOf;
    exports.optional = decoders_1.optional;
    exports.props = decoders_1.props;
    exports.string = decoders_1.string;
    exports.try_ = decoders_1.try_;
    exports.undefined_ = decoders_1.undefined_;
});
//# sourceMappingURL=index.js.map